#include <QtWidgets>

void showContextMenu()
{
    QMenu mainMenu;

    mainMenu.addAction("Action 1");
    mainMenu.addAction("Action 2");

    QMenu *subMenu1 = mainMenu.addMenu("Sub Menu 1");
    subMenu1->addAction("Action 3");
    subMenu1->addAction("Action 4");

    mainMenu.exec(QCursor::pos());
}

int main(int argc, char** argv)
{
    QApplication app(argc, argv);

    QLabel label("open context menu");
    QObject::connect(&label, &QWidget::customContextMenuRequested,
                     &showContextMenu);
    label.setContextMenuPolicy(Qt::CustomContextMenu);

    label.show();

    return app.exec();
}
